import {
  Emitter
} from "./chunk-LYDX5BFI.js";
import {
  uuid
} from "./chunk-CZZTWTGB.js";
import {
  useDispose
} from "./chunk-CLQAILWG.js";

// src/common/msg/channel.ts
var Channel = class extends Emitter {
  constructor() {
    super(...arguments);
    this.id = uuid();
    this.dispose = useDispose();
  }
  /** @deprecated use .dispose() */
  close() {
    void this.dispose();
  }
};
var LocalChannel = class extends Channel {
  constructor() {
    super(...arguments);
    this.isConnected = true;
  }
  postMessage(data) {
    void this.other?.emit("message", {
      data,
      // : cloneObject(data),
      origin: "local",
      lastEventId: uuid()
    });
  }
};
function createLocalChannelPair() {
  const w1 = new LocalChannel();
  const w2 = new LocalChannel();
  w1.other = w2;
  w2.other = w1;
  return [w1, w2];
}

export {
  Channel,
  LocalChannel,
  createLocalChannelPair
};
//# sourceMappingURL=chunk-2WVJKTLX.js.map